
/* quelques fonctions pour faire de l'interpolation */

Lagrange2(X,Y,x)=
{my(P);
P=polinterpolate(vector(length(X),i,X[i]^2),Y,x);
return(subst(P,x,x^2));
}


Lagrange4(X,Y,x)=
{my(P);
P=polinterpolate(vector(length(X),i,X[i]^4),Y,x);
return(subst(P,x,x^4));
}


InterFracTri(X,Y,dNt,dDt,dNy,dDy,dNz,dDz)=  // à tester
{my(x,y,z,M,K,L,PXXX,PYN,PYD,PXXN,PXXD,PXN,PXD,PXYXN,PXYXD,sN,sD,PZN,PZD);
x='x;
y='y;
z='z;

PXXX=vector(dNy+dDy+2);
PYN=vector(max(dNz,dDz)+1);
PYD=vector(max(dNz,dDz)+1);

for(ii=1,max(dNz,dDz)+1,
   for(jj=1,dNy+dDy+2,
      M=matrix(2+dNt+dDt,2+dNt+dDt,n,m,if(m<2+dNt,X[1][n]^(m-1),-Y[n][jj][ii]*X[1][n]^(m-2-dNt)));
      K=matker(M);
      L=[0,0];
      for(j=0,1,
          for(i=1,1+dDt*j+dNt*(1-j),
             L[j+1]+=K[i+(dNt+1)*j,1]*x^(i-1)));
      PXXX[jj]=L[1]/L[2]);


   PXXN=vector(dNy+1,i,numerator(PXXX[i])/polcoeff(denominator(PXXX[i]),0)); \\normalisation
   PXXD=vector(dDy+1,i,denominator(PXXX[i])/polcoeff(denominator(PXXX[i]),0)); \\normalisation

   PXN=vector(dNt+1,j,vector(dNy+1,i,polcoeff(PXXN[i],j-1,x))); \\ interpolation coefficient par coefficient
   PXD=vector(dDt+1,j,vector(dDy+1,i,polcoeff(PXXD[i],j-1,x))); \\ interpolation coefficient par coefficient

   PXYXN=vector(dNt+1,i,polinterpolate(vector(dNy+1,j,X[2][j]),vector(dNy+1,j,PXN[i][j]),y/x));
   PXYXD=vector(dDt+1,i,polinterpolate(vector(dDy+1,j,X[2][j]),vector(dDy+1,j,PXD[i][j]),y/x));
   sN=0;for(i=0,dNt,sN+=PXYXN[i+1]*x^i);
   sD=0;for(i=0,dDt,sD+=PXYXD[i+1]*x^i);
   
   PYN[ii]=sN;
   PYD[ii]=sD;
);

PZN=vector(dNy+1,i,vector(dNt+1,j,vector(dNz+1,k,polcoeff(polcoeff(PYN[k],i-1,y),j-1,x))));
sN=0;
for(i=0,dNy,
   for(j=0,dNt,
      sN+=polinterpolate(vector(dNz+1,k,X[3][k]),PZN[i+1][j+1],z/x)*x^j*y^i;
));

PZD=vector(dDy+1,i,vector(dDt+1,j,vector(dDz+1,k,polcoeff(polcoeff(PYD[k],i-1,y),j-1,x))));
sD=0;
for(i=0,dDy,
   for(j=0,dDt,
      sD+=polinterpolate(vector(dDz+1,k,X[3][k]),PZD[i+1][j+1],z/x)*x^j*y^i;
));

return(sN/sD);

}


InterPolTri(X,Y)=  // à tester
{my(x,y,z,M,K,L,dx,dy,dz,PXXX,PYN,PXN,PXYX,sN,PZN);
x='x;
y='y;
z='z;
dx=length(X[1]);  \\ degré en x +1
dy=length(X[2]);
dz=length(X[3]);

PXXX=vector(dy);
PYN=vector(dz);

for(kk=1,dz, 
   for(jj=1,dy, 
      PXXX[jj]=polinterpolate(X[1],vector(dx,i,Y[i][jj][kk]),x); 
   ); 

   PXN=vector(dx+1,j,vector(dy,i,polcoeff(PXXX[i],j-1,x))); \\ interpolation coefficient par coefficient

   PXYX=vector(dx+1,i,polinterpolate(X[2],vector(dy,j,PXN[i][j]),y));
   sN=0;for(i=0,dx,sN+=PXYX[i+1]*x^i);
   
   PYN[kk]=sN;
);

PZN=vector(dy+1,i,vector(dx+1,j,vector(dz,k,polcoeff(polcoeff(PYN[k],i-1,y),j-1,x))));
sN=0;
for(i=0,dy,
   for(j=0,dx,
      sN+=polinterpolate(X[3],PZN[i+1][j+1],z)*x^j*y^i;
));


return(sN);

}


InterUni1(X,Y,x,B,aa)=    \\ 2+dA+dB <= length(X), length(Y)
{my(M,L,dA,dB,K);
dA=B;
dB=B;

if(round(Y*10^500==0),return(0));

if(aa==1,M=matrix(2+dA+dB,2+dA+dB,n,m,if(m<2+dA,X[n]^(m-1),-Y[n]*X[n]^(m-2-dA))));
if(aa==2,M=matrix(2+dA+dB,2+dA+dB,n,m,if(m<2+dA,X[n]^(2*(m-1)+1),-Y[n]*X[n]^(2*(m-2-dA)))));
if(aa==3,M=matrix(2+dA+dB,2+dA+dB,n,m,if(m<2+dA,X[n]^(2*(m-1)),-Y[n]*X[n]^(2*(m-2-dA)))));
K=matker(M);if(length(K)==0,print("aucune solution trouvée"));

L=[0,0];
for(j=0,1,
    for(i=1,1+dB*j+dA*(1-j),
         if(aa==1,L[j+1]+=K[i+(dA+1)*j,1]*x^(i-1));
         if(aa==2,L[j+1]+=K[i+(dA+1)*j,1]*x^(2*(i-1)+(j+1)%2));
         if(aa==3,L[j+1]+=K[i+(dA+1)*j,1]*x^(2*(i-1)))));

return(L[1]/L[2]);

}


InterUni2(X,Y,x,BN,BD,aa)=    \\ 2+dA+dB <= length(X), length(Y)
{my(M,L,dA,dB,K);
dA=BN;
dB=BD;

if(round(Y*10^round(default(realprecision,)/2))==0,return(0));


if(aa==1,M=matrix(2+dA+dB,2+dA+dB,n,m,if(m<2+dA,X[n]^(m-1),-Y[n]*X[n]^(m-2-dA))));
if(aa==2,M=matrix(2+dA+dB,2+dA+dB,n,m,if(m<2+dA,X[n]^(2*(m-1)+1),-Y[n]*X[n]^(2*(m-2-dA)))));
if(aa==3,M=matrix(2+dA+dB,2+dA+dB,n,m,if(m<2+dA,X[n]^(2*(m-1)),-Y[n]*X[n]^(2*(m-2-dA)))));
K=matker(M);if(length(K)==0,print("aucune solution trouvée"));

L=[0,0];
for(j=0,1,
    for(i=1,1+dB*j+dA*(1-j),
         if(aa==1,L[j+1]+=K[i+(dA+1)*j,1]*x^(i-1));
         if(aa==2,L[j+1]+=K[i+(dA+1)*j,1]*x^(2*(i-1)+(j+1)%2));
         if(aa==3,L[j+1]+=K[i+(dA+1)*j,1]*x^(2*(i-1)))));

return(L[1]/L[2]);
}



ValRat(xx,N)=  \\ tant que valeur suivante n'est pas égale au lieu de N?
{my(L,som,yy);
if(abs(xx-round(xx))<10^-300,return(round(xx)));   // il faudrait pouvoir régler la précision
L=[floor(xx),1/(xx-floor(xx))];
for(i=1,N,yy=L[length(L)];
   if(abs(yy-round(yy))>10^-300,
      L=concat(L[1..length(L)-1],[floor(yy),1/(yy-floor(yy))]),L[length(L)]=round(yy);break)
);

L[length(L)]=floor(L[length(L)]);
som=L[length(L)];
for(i=1,length(L)-1,som=1/som+L[length(L)-i]);
return(som);
}

