install ("eval10theta2", "Gp", , "./theta.so");
install ("eval10theta2Newton", "Gp", , "./theta.so");
install ("eval3bj", "Gp", , "./theta.so");
install ("eval4theta", "Gp", , "./theta.so");
install ("borchardt", "Gp", , "./theta.so");
install ("h4h10h12h16FromTh2", "Gp", , "./theta.so");
install ("I2I4I6I10Fromh4h10h12h16", "Gp", , "./theta.so");
install ("StrengInvFromI2I4I6I10", "Gp", , "./theta.so");

\r molin.gp
\r cmh.gp


\\ MM=read("actionG24")
fctPolThetaG2(t1,t2,t3,M,realprec,MM,l)=
{my(tau,T);
default(realprecision,realprec);
tau=TauFromBjp(t1,t2,t3,MM);     \\Newton ? 
T=PolThetaG2(tau,M,l);
return(T);
}


fctPolStreng(i1,i2,i3,M,realprec,l)=
{my(tau,T);
default(realprecision,realprec);
tau=TauFromJinv(i1,i2,i3);
T=PolStrengG2(tau,M,l);
return(T);
}


PolThetaG2(tau,M,l)=
{my(x,nb,ValBjp,phi,psi2);   
x='x;
nb=1+l+l^2+l^3;

ValBjp=vector(nb,i,EvalBjp(l*Mtau(M[i],tau)));

phi=prod(i=1,nb,x-ValBjp[i][1]);
  \\psi2=0;psi3=0;for(i=1,nb,dd=divrem(phi,x-ValBjp[i][1])[1];psi2+=ValBjp[i][2]*dd;psi3+=ValBjp[i][3]*dd);
psi2=sum(i=1,nb,ValBjp[i][2]*divrem(phi,x-ValBjp[i][1])[1]);

\\return(vector(nb,i,polcoeff(phi,i-1,x)));
return([vector(nb,i,polcoeff(phi,i-1,x)),vector(nb,i,polcoeff(psi2,i-1,x))]);
  \\return([vector(nb,i,polcoeff(phi,i-1,x)),vector(nb,i,polcoeff(psi2,i-1,x)),vector(nb,i,polcoeff(psi3,i-1,x))]);
}



PolStrengG2(tau,M,l)=
{my(ValJ,phi,ValJ2,psi2,psi3,x,nb);
nb=l^3+l^2+l+1;
x='x;
ValJ=vector(nb,i,EvalJinvStreng(l*Mtau(M[i],tau)));
phi=prod(i=1,nb,x-ValJ[i][1]);

ValJ2=vector(nb,i,divrem(phi,x-ValJ[i][1])[1]);
psi2=sum(i=1,nb,ValJ[i][2]*ValJ2[i]);
psi3=sum(i=1,nb,ValJ[i][3]*ValJ2[i]);


\\return(vector(nb,i,polcoeff(phi,i-1,x)));
return([vector(nb,i,polcoeff(phi,i-1,x)),vector(nb,i,polcoeff(psi2,i-1,x)),vector(nb,i,polcoeff(psi3,i-1,x))]);
}




/************ DEBUT Inversion ***********/

IgToStr(III)={my(j1,j2,j3);[j1,j2,j3]=III;return([j2*(j2-3*j3)/2/j1,j2^2/j1,j2^5/j1^3]);}
StrToIg(JJJ)={my(i1,i2,i3);[i1,i2,i3]=JJJ;return([i2^5/i3^2,i2^3/i3,i2^2*(i2-2*i1)/3/i3]);}


TauFromBjp(t1,t2,t3,actG24)=
{my(Bj,t0,JJJ,P,E,Bj2,tau,FTS,test,taup,realprec);
Bj=vector(9);
\\N=300;
realprec=default(realprecision,);
default(realprecision,realprec+10);

t0=1+t1^2+t2^2+t3^2;
Bj[1]=2*(t1+t2*t3)/t0;
Bj[2]=2*(t2+t1*t3)/t0;
Bj[3]=2*(t3+t1*t2)/t0;
Bj[4]=(1-t1^2+t2^2-t3^2)/t0;
Bj[5]=2*(t2-t1*t3)/t0;
Bj[6]=(1+t1^2-t2^2-t3^2)/t0;
Bj[7]=2*(t1-t2*t3)/t0;
Bj[8]=(1-t1^2-t2^2+t3^2)/t0;
Bj[9]=2*(t3-t1*t2)/t0;

\\[III,JJJ]=JInvStrengFromBj(concat([1],Bj));
JJJ=JInvStrengFromBj(concat([1],Bj))[2];
\\III=JInvStrengFromBj(concat([1],Bj),1000);JJJ=invariants_streng_to_igusaclebsch(III);

default(realprecision,4000);
P=curve_from_igusaclebsch_on_C(JJJ);
E=polroots(P);
\\print(InvIgusaPol(P)[2]-III);

default(realprecision,realprec+10);
Bj2=EvalBjFromCurveEq(E,realprec);
tau=EvalTauFrombj(Bj2);  
tau=ReduceToF2(tau)[2];
\\print(JinvG2(tau)[2]-III);


\\ trouver taup / bjp(taup)=t1,t2,t3
FTS=OrdreEtSigne([Bj[1],Bj[2],Bj[3],Bj[4],0,Bj[5],0,Bj[6],Bj[7],0,0,Bj[8],0,0,Bj[9]],EvalBj(tau));
test=0;


for(i=1,11520,if(test==0&&correspond(actG24[i][2][1],FTS[1])&&correspond(actG24[i][2][2],FTS[2]),test=1;taup=Mtau(actG24[i][1],tau)));
if(test==0,print("problème 1"));

\\print(EvalBjp(taup,N)-[t1,t2,t3]);


return(taup);
\\return(PolThetaG2(taup,M,l));
}

correspond(L,M)=  \\ L,M listes de 10 éléments tous différents dans L et répétitions possibles dans M
{my(test);
test=1;for(i=1,10,if(!dansL(M[i],L[i]),test=0));
return(test);
}




TauFromRose(r1,r2,r3,actG2)=
{my(E,Bj2,tau,Th4Thomae,Th4Tau,test,taup,FTS);

\\P=x*(x-1)*(x-2)*(x-2*r1/(1+r1))*(x-2*r2/(1+r2))*(x-2*r3/(1+r3));   \\ transformation x=x'/(2-x')  et y=sqrt(2(1+r1)(1+r2)(1+r3))/I/(2-x')^3y'

E=[0,1,2,2*r1/(1+r1),2*r2/(1+r2),2*r3/(1+r3)];
Bj2=EvalBjFromCurveEq(E,round(default(realprecision,)));
tau=EvalTauFrombj(Bj2);  
tau=ReduceToF2(tau)[2];


Th4Thomae=bjthomae([E[2],E[4],E[5],E[6],E[3],E[1]]);

Th4Tau=Eval10Theta2(tau);Th4Tau=vector(9,i,Th4Tau[i+1]^2/Th4Tau[1]^2);
Th4Tau=[Th4Tau[1],Th4Tau[2],Th4Tau[3],Th4Tau[4],0,Th4Tau[5],0,Th4Tau[6],Th4Tau[7],0,0,Th4Tau[8],0,0,Th4Tau[9]];

FTS=OrdreEtSigne(Th4Thomae,Th4Tau);

test=0;

for(i=1,720,if(test==0&&correspond(actG2[i][2][1],FTS[1])&&correspond(actG2[i][2][2]%2,FTS[2]/2),test=1;taup=Mtau(actG2[i][1],tau)));  \\ %2 car actG2 expo des th^2 et ici th^4
if(test==0,print("problème 1"));


if(round(10^100*(Rosenhain(taup)-[r1,r2,r3]))!=0,print("erreur 186"));

/*
default(realprecision,200);
test=0;for(i=1,720,if(test==0&&round(10^100*(Rosenhain(Mtau(NN[i][1],tau))-[r1,r2,r3]))==0,test=i));
taup=Mtau(NN[test][1],tau);
*/

return(taup);
}






proche(X,Y,precs)=
{return(abs(X-Y)<precs||abs(X+Y)<precs||abs(X+I*Y)<precs||abs(X-I*Y)<precs)};

proche2(X,Y,precs)={
return(abs(real(X)-real(Y))<precs&&abs(imag(X)-imag(Y))<precs)};


OrdreEtSigne(Bj,Bj2)=  \\Bj=Bj(taup)=Bj(gam.tau)  Bj2=Bj(tau)
{my(Perm,Signe,precs,test,cd,cst,ee,Tab);

precs=10^-50;
Tab=[1,2,3,4,6,8,9,12,15];

cst=1;
test=0;
for(i=1,15,if(proche(Bj[1],Bj2[i],precs),test=1));

if(test==0,  \\trouver "cst"
   for(i=1,15,
      for(j=1,15,
         if(abs(Bj2[i])>precs&&proche(1/Bj2[i],Bj[j],precs),    \\ cas ultra foireux: Bj2[1]==Bj2[2] et cd=1 ou 2 (cf perm)
            test=1;cd=i;cst=1/Bj2[i]))));
if(test==0,print("problème 2"));

Perm=vector(15);
for(i=1,15,
   Perm[i]=[];
   for(j=1,15,
      if(proche(Bj[i],Bj2[j]*cst,precs), 
         Perm[i]=concat(Perm[i],[j]))));

for(i=1,15,if(Perm[i]==[], Perm[i]=[cd];ee=i;Bj2[cd]=1  , for(j=1,length(Perm[i]),if(Perm[i][j]==cd,Perm[i]=Perm[i][^j];break))));
\\print(Perm);

Signe=vector(15);
for(i=1,15,Signe[i]=vector(length(Perm[i]),j,
   if(proche2(Bj[i],cst*Bj2[Perm[i][j]],precs),0,
   if(proche2(Bj[i],-cst*Bj2[Perm[i][j]],precs),2,
   if(proche2(Bj[i],I*cst*Bj2[Perm[i][j]],precs),3,
   if(proche2(Bj[i],-I*cst*Bj2[Perm[i][j]],precs),1,
   print("problème 3 "i" "j))))))); 

if(cst==1,cd=0,Perm[ee]=[0]);
return([concat([[cd]],vector(9,i,Perm[Tab[i]])),concat([[0]],vector(9,i,Signe[Tab[i]]))]);
}





TauFromJinvStr(i1,i2,i3)=
{my(III,JJJ,P,E,Bj,tau);
III=[i1,i2,i3];
JJJ=invariants_streng_to_igusaclebsch(III);
P=curve_from_igusaclebsch_on_C(JJJ);
E=polroots(P); 
Bj=EvalBjFromCurveEq(E,default(realprecision,));
tau=ReduceToF2(EvalTauFrombj(Bj))[2];
return(tau);
}


EvalTauFrombj(b)=      
{my(T,tau1,tau2,tau3,a);
T=vector(16);
T[1]=borchardt([b[1],b[2],b[3]])^(-1);
for(j=2,16,T[j]=T[1]*b[j-1]);
tau1=(-I*T[5]*borchardt([T[1]/T[5],T[7]/T[5],T[3]/T[5]]))^(-1);
tau2=(-I*T[9]*borchardt([T[10]/T[9],T[1]/T[9],T[2]/T[9]]))^(-1);
a=(T[1]*borchardt([T[9]/T[1],T[5]/T[1],T[13]/T[1]]))^(-1);
tau3=sqrt(a+tau1*tau2);
return([tau1,tau3;tau3,tau2]);
}


EvalTauFromb123(b)=
{my(T,R,tau1,tau2,tau3,a,V0,V1,V2,V4,V6,V8,V9,V12);
T=vector(4);
R=vector(4);
T[1]=borchardt([b[1],b[2],b[3]])^(-1);  \\ valable pour tau dans F2
for(j=2,4,T[j]=T[1]*b[j-1]);
for(j=1,4,R[j]=sqrt(T[j]));
V0=(T[1]+T[2]+T[3]+T[4])/4;
V1=(R[1]*R[2]+R[3]*R[4])/2;
V2=(R[1]*R[3]+R[2]*R[4])/2;
\\V3=(R[1]*R[4]+R[2]*R[3])/2;
V4=(T[1]-T[2]+T[3]-T[4])/4;
V6=(R[1]*R[3]-R[2]*R[4])/2;
V8=(T[1]+T[2]-T[3]-T[4])/4;
V9=(R[1]*R[2]-R[3]*R[4])/2;
V12=(T[1]-T[2]-T[3]+T[4])/4;
\\V15=(R[1]*R[4]-R[2]*R[3])/2;
tau1=(-2*I*V4*borchardt([V0/V4,V6/V4,V2/V4]))^(-1);
tau2=(-2*I*V8*borchardt([V9/V8,V0/V8,V1/V8]))^(-1);
a=(4*V0*borchardt([V8/V0,V4/V0,V12/V0]))^(-1);
tau3=sqrt(a+tau1*tau2);
tau3-=round(real(tau3));
return([tau1,tau3;tau3,tau2]);
}



/************ Fin Inversion ***********/

/************ DEBUT Espace de Siegel et Groupe symplectique ***********/


         /*** I Espace de Siegel ***/


dansH2(tau)=   \\matrices symétriques complexes dont la partie imaginaire est définie positive
{my(P,x,precs);
x='x;
precs=floor(min(100,default(realprecision,)/2));
P=polroots(matdet(imag(tau)-x*matid(2)));
return( (abs(real(tau[1,2]-tau[2,1]))<10^(-precs)) &&
         (abs(imag(tau[1,2]-tau[2,1]))<10^(-precs)) &&
         ((round(10^precs*real(P[1]))>0) && (abs(imag(P[1]))<10^(-precs))&&
	 ((round(10^precs*real(P[2]))>0) && (abs(imag(P[2]))<10^(-precs)))));}


dansDomFond(tau)=
{my(test,N);

N=min(100,floor(default(realprecision,)/2));
test=1;

for(i=1,19,if(abs(matdet(MatNj(i)[3..4,1..2]*tau+MatNj(i)[3..4,3..4]))<1-10^-N,test=0));

return(dansH2(tau)&&test==1&&abs(real(tau[1,1]))<=1/2+10^-N&&abs(real(tau[2,1]))<=1/2+10^-N&&abs(real(tau[2,2]))<=1/2+10^-N&&
imag(tau[2,2])-imag(tau[1,1])>=-10^-N&&imag(tau[1,1])-2*imag(tau[2,1])>=-10^-N&&imag(tau[2,1])>=-10^-N);
}



MinkowskiReduction(M)=  \\ matrice sym réelle définie positive
{my(t,U,q,precs,x,P);

precs=min(100,floor(default(realprecision,)/2));

if(round((M[1,2]-M[2,1])*10^precs)!=0,print("erreur: matrice non symétrique"));
x='x;P=polroots(matdet(M-x*matid(2)));if(round(P[1]*10^precs)<0||round(P[2]*10^precs)<0,print("erreur: matrice non définie positive"));

t=1;
U=matid(2);

while(t,
   if(round((2*abs(M[1,2])-abs(M[1,1]))*10^precs)<=0,
      if(round((abs(M[1,1])-abs(M[2,2]))*10^precs)<=0,
         if(round(M[1,2]*10^precs)<=0,
            M=[1,0;0,-1]*M*[1,0;0,-1];
            U=[1,0;0,-1]*U;
           );
         t=0,
         M=[0,1;-1,0]*M*[0,-1;1,0];
         U=[0,1;-1,0]*U)
    ,                                \\ correction par rapport à Régis
   q=round(M[1,2]/M[1,1]);
\\   if(round(abs(M[1,2]/M[1,1]-floor(M[1,2]/M[1,1]))*10^precs)==1/2,q-=1);   \\inutile je crois car déjà testé 
   M=[1,0;-q,1]*M*[1,-q;0,1];
   U=[1,0;-q,1]*U)
);

if(round((M[2,2]-M[1,1])*10^precs)<0||round((M[1,1]-2*M[2,1])*10^precs)<0||round(M[2,1]*10^precs)<0,print("erreur réduction Minkowski");print(M););
\\ réduit si c>=a et a>=2b>=0

return(U);
}


MatNj(j)=
{return(
[[0,0,-1,0;0,0,0,-1;1,0,0,0;0,1,0,0],
[0,0,-1,0;0,0,0,-1;1,0,1,0;0,1,0,0],
[0,0,-1,0;0,0,0,-1;1,0,-1,0;0,1,0,0],
[0,0,-1,0;0,0,0,-1;1,0,0,0;0,1,0,1],
[0,0,-1,0;0,0,0,-1;1,0,0,0;0,1,0,-1],
[0,0,-1,0;0,0,0,-1;1,0,1,0;0,1,0,1],
[0,0,-1,0;0,0,0,-1;1,0,-1,0;0,1,0,-1],
[0,0,-1,0;0,0,0,-1;1,0,-1,0;0,1,0,1],
[0,0,-1,0;0,0,0,-1;1,0,1,0;0,1,0,-1],
[0,0,-1,0;0,0,0,-1;1,0,0,1;0,1,1,0],
[0,0,-1,0;0,0,0,-1;1,0,0,-1;0,1,-1,0],
[0,0,-1,0;0,0,0,-1;1,0,1,1;0,1,1,0],
[0,0,-1,0;0,0,0,-1;1,0,-1,-1;0,1,-1,0],
[0,0,-1,0;0,0,0,-1;1,0,0,1;0,1,1,1],
[0,0,-1,0;0,0,0,-1;1,0,0,-1;0,1,-1,-1],
[1,0,-1,0;0,1,0,-1;1,0,0,0;0,0,0,1],
[1,0,-1,0;0,1,0,-1;0,0,1,0;0,1,0,0],
[1,0,0,0;0,1,0,0;1,-1,1,0;-1,1,0,1],
[-1,0,0,0;0,-1,0,0;1,-1,-1,0;-1,1,0,-1]][j]);
}


ReduceToF2(tau)=
{my(gam,t,U,U2,a,N,Nj,precs);
precs=default(realprecision,)/2;
if(dansH2(tau)==0,print("erreur5: tau n'est pas dans H2");print(tau););
gam=matid(4);
t=1;
while(t,
 U=MinkowskiReduction(imag(tau));
 U2=(U^(-1))~;
 gam=[U[1,1],U[1,2],0,0;
      U[2,1],U[2,2],0,0;
      0,0,U2[1,1],U2[1,2];
      0,0,U2[2,1],U2[2,2]]*gam;
 tau=U*tau*(U~);

 a=-round(real(tau[1,1]));
 N=[1,0,1,0;0,1,0,0;0,0,1,0;0,0,0,1]^a;
 tau=Mtau(N,tau);
 gam=N*gam;
 
 a=-round(real(tau[2,2]));
 N=[1,0,0,0;0,1,0,1;0,0,1,0;0,0,0,1]^a;
 tau=Mtau(N,tau);
 gam=N*gam;

 a=-round(real(tau[2,1]));
 N=[1,0,0,1;0,1,1,0;0,0,1,0;0,0,0,1]^a;
 tau=Mtau(N,tau);
 gam=N*gam;

 t=0;
 for(j=1,19,
	Nj=MatNj(j);
	if(abs(matdet(Nj[3..4,1..2]*tau+Nj[3..4,3..4]))<(1-10^-precs),
                t=1;
                tau=Mtau(Nj,tau);
                gam=Nj*gam;
          )
    )
 );

return([gam,tau]);
}



         /*** II Groupe Symplectique ***/

/*
genG2()=
{my(J,M1,M2,M3);
J=[0,0,-1,0;0,0,0,-1;1,0,0,0;0,1,0,0];
M1=[1,0,1,0;0,1,0,0;0,0,1,0;0,0,0,1];
M2=[1,0,0,0;0,1,0,1;0,0,1,0;0,0,0,1];
M3=[1,0,0,1;0,1,1,0;0,0,1,0;0,0,0,1];
return([J,M1,M2,M3]);
}
*/


ConjTauG2(l)=  \\renvoie représentants de Gamma_2/Gamma_2(l)
{my(L);
L=[];
for(i=0,l-1,for(j=0,l-1,for(k=0,l-1,L=concat(L,[[1,0,0,0;0,1,0,0;i,j,1,0;j,k,0,1]]))));
for(i=0,l-1,for(j=0,l-1,for(k=0,l-1,if((i*k)%l==j^2%l,L=concat(L,[[0,0,-1,0;0,0,0,-1;1,0,i,j;0,1,j,k]])))));
for(i=0,l-1,L=concat(L,[[1,0,0,0;0,0,0,-1;0,0,1,i;-i,1,0,0]]));
L=concat(L,[[-1,-1,1,-1;0,0,-1,1;0,0,0,-1;1,0,0,-1]]);

return(L);
}




         /*** III Action ***/


Mtau(M,tau)={return((M[1..2,1..2]*tau+M[1..2,3..4])*(M[3..4,1..2]*tau+M[3..4,3..4])^-1);}


/*
action(gam)=
{my(Tab,Perm,Sign,S);

Tab=[[[0;0],[0;0]],[[0;0],[1;0]],[[0;0],[0;1]],[[0;0],[1;1]],[[1;0],[0;0]],[[1;0],[0;1]],[[0;1],[0;0]],[[0;1],[1;0]],[[1;1],[0;0]],[[1;1],[1;1]]];

[Perm,Sign]=FormTrans(gam);
S=[];
for(i=1,10,S=concat(S,[  fct(EXPOS(gam,Tab[i][1],Tab[i][2]),Sign[i])   ]));

return([Perm,S]);
}
*/

/*
action(gam,Bj)= \\length(Bj)=9  \\renvoie Bj^2(gam.tau)
{my(FT,T,Perm,Tab,Sign,Bj2);

(fct(nb)=if(nb<=4,nb++,if(nb==6,6,if(nb<10,nb--,if(nb==12,9,10)))));

FT=FormTrans(gam)[1];
T=[1,2,3,4,5,7,9,10,13,16];
Perm=vector(10,i,fct(4*FT[T[i]][1]+8*FT[T[i]][2]+FT[T[i]][3]+2*FT[T[i]][4]));

Tab=[[[0;0],[0;0]],[[0;0],[1;0]],[[0;0],[0;1]],[[0;0],[1;1]],[[1;0],[0;0]],[[1;0],[0;1]],[[0;1],[0;0]],[[0;1],[1;0]],[[1;1],[0;0]],[[1;1],[1;1]]];
Sign=vector(10,i,expos(gam,Tab[i][1],Tab[i][2])[1,1]);

Bj=concat([1],Bj);
Bj2=vector(10,i,Bj[Perm[i]]*Sign[i]^4)/Bj[Perm[1]];   \\ici ^2 car j'ai Bj^2 pour formule Thomae

return(Bj2[2..10]);
}
*/


expos(gam,a,b)=
{my(A,B,C,D);
[A,B,C,D]=[gam[1..2,1..2],gam[1..2,3..4],gam[3..4,1..2],gam[3..4,3..4]];
return(exp(-I*Pi/4*(a~*A*(B~)*a+b~*C*(D~)*b+2*a~*B*(C~)*b+2*(a~*A+b~*C+[(A~*C)[1,1];(A~*C)[2,2]]~)*[(D~*B)[1,1];(D~*B)[2,2]]))[1,1]);
}


FormTrans(gam)=
{my(A,B,C,D,T,L,M);
T=[[0,0,0,0],[0,0,1,0],[0,0,0,1],[0,0,1,1],[1,0,0,0],[1,0,1,0],[1,0,0,1],[1,0,1,1],[0,1,0,0],[0,1,1,0],[0,1,0,1],[0,1,1,1],[1,1,0,0],[1,1,1,0],[1,1,0,1],[1,1,1,1]];

[A,B,C,D]=[gam[1..2,1..2],gam[1..2,3..4],gam[3..4,1..2],gam[3..4,3..4]];

L=[];
for(i=1,16,L=concat(L,[(gam~)*(T[i]~)+[(A~*C)[1,1],(A~*C)[2,2],(D~*B)[1,1],(D~*B)[2,2]]~]));

M=vector(16);
for(i=1,16,M[i]=CalculSigne(L[i]));   

return([L%2,M]);
}


CalculSigne(L)=   \\thet[a+n,b+m]-> exp(2*I*Pi*a~*m)*thet[a,b] , a,b dans Z^2/(2*Z^2) et n,m dans Z^2
{my(LL,LLL);
LL=L%2;
LLL=1/2*L-1/2*LL;
return(-((LL[1]*LLL[3]+LL[2]*LLL[4])%2));    \\exp(2*I*Pi*a~*m)   attention: parenthésage très important
}





/************ FIN Espace de Siegel et Groupe symplectique ***********/



/********* DEBUT Evaluation des fct theta *********/


            /**** I) Evaluation des j-invariants ****/





EvalJinvIgusa(tau)=  \\evaluation des j-invariants de Streng, pour tau dans H2
{my(th2,h,Ig,I2,I4,I6,I10);
tau=ReduceToF2(tau)[2];  
th2=eval10theta2(tau);      \\th2=eval10theta2Newton(tau); ??
h=h4h10h12h16FromTh2(th2);
Ig=I2I4I6I10Fromh4h10h12h16(h);
[I2,I4,I6,I10]=Ig;

return([I2^5/I10,I2^3*I4/I10,I2^2*I6/I10]);
}     


EvalJinvStreng(tau)=  \\evaluation des j-invariants de Streng, pour tau dans H2
{my(th2,h,Ig,I2,I4,I6,I10,I6p);
tau=ReduceToF2(tau)[2];  
th2=eval10theta2(tau);      \\th2=eval10theta2Newton(tau); ??
h=h4h10h12h16FromTh2(th2);
Ig=I2I4I6I10Fromh4h10h12h16(h);
[I2,I4,I6,I10]=Ig;
I6p=(I2*I4-3*I6)/2;

return([I4*I6p/I10,I2*I4^2/I10,I4^5/I10^2]); 
}



JinvG2(tau)=  \\calcule les invariants d'Igusa et de Streng en utilisant la définition avec les formes modulaires h_i
{my(h4,h10,h12,h16,Th,h6,T,s,L,M);
Th=eval10theta2(ReduceToF2(tau)[2]);

h4=0;
for(i=1,10,h4+=Th[i]^4);
h10=prod(i=1,10,Th[i]);

L=[(Th[1]*Th[2]*Th[3]*Th[5]*Th[7]*Th[10])^2,(Th[1]*Th[2]*Th[3]*Th[6]*Th[8]*Th[9])^2,(Th[1]*Th[2]*Th[4]*Th[5]*Th[8]*Th[10])^2,(Th[1]*Th[2]*Th[4]*Th[6]*Th[7]*Th[9])^2,(Th[1]*Th[2]*Th[5]*Th[6]*Th[9]*Th[10])^2,(Th[1]*Th[3]*Th[4]*Th[5]*Th[8]*Th[9])^2,(Th[1]*Th[3]*Th[4]*Th[6]*Th[7]*Th[10])^2,(Th[1]*Th[3]*Th[7]*Th[8]*Th[9]*Th[10])^2,(Th[1]*Th[4]*Th[5]*Th[6]*Th[7]*Th[8])^2,(Th[2]*Th[3]*Th[4]*Th[5]*Th[7]*Th[9])^2,(Th[2]*Th[3]*Th[4]*Th[6]*Th[8]*Th[10])^2,(Th[2]*Th[3]*Th[5]*Th[6]*Th[7]*Th[8])^2,(Th[2]*Th[4]*Th[7]*Th[8]*Th[9]*Th[10])^2,(Th[3]*Th[4]*Th[5]*Th[6]*Th[9]*Th[10])^2,(Th[5]*Th[6]*Th[7]*Th[8]*Th[9]*Th[10])^2];

h12=sum(i=1,15,L[i]);

M=[(Th[4]^4+Th[6]^4+Th[8]^4+Th[9]^4),(Th[4]^4+Th[5]^4+Th[7]^4+Th[10]^4),(Th[3]^4+Th[6]^4+Th[7]^4+Th[9]^4),(Th[3]^4+Th[5]^4+Th[8]^4+Th[10]^4),(Th[3]^4+Th[4]^4+Th[7]^4+Th[8]^4),(Th[2]^4+Th[6]^4+Th[7]^4+Th[10]^4),(Th[2]^4+Th[5]^4+Th[8]^4+Th[9]^4),(Th[2]^4+Th[4]^4+Th[5]^4+Th[6]^4),(Th[2]^4+Th[3]^4+Th[9]^4+Th[10]^4),(Th[1]^4+Th[6]^4+Th[8]^4+Th[10]^4),(Th[1]^4+Th[5]^4+Th[7]^4+Th[9]^4),(Th[1]^4+Th[4]^4+Th[9]^4+Th[10]^4),(Th[1]^4+Th[3]^4+Th[5]^4+Th[6]^4),(Th[1]^4+Th[2]^4+Th[7]^4+Th[8]^4),(Th[1]^4+Th[2]^4+Th[3]^4+Th[4]^4)];

h16=sum(i=1,15,L[i]*M[i]);

T=[[0,0,0,0],[0,0,1,0],[0,0,0,1],[0,0,1,1],[1,0,0,0],[1,0,0,1],[0,1,0,0],[0,1,1,0],[1,1,0,0],[1,1,1,1]];

h6=0;
for(i=1,7,for(j=i+1,8,for(k=j+1,9,for(l=k+1,10,
s=T[i]+T[j]+T[k]+T[l];
if(s[1]%2==0&&s[2]%2==0&&s[3]%2==0&&s[4]%2==0,
h6+=signes(i,j,k)*(Th[i]*Th[j]*Th[k])^2+
    signes(i,j,l)*(Th[i]*Th[j]*Th[l])^2+
    signes(i,k,l)*(Th[i]*Th[k]*Th[l])^2+
    signes(j,k,l)*(Th[j]*Th[k]*Th[l])^2)))));

return([[h12^5/h10^6,h4*h12^3/h10^4,h16*h12^2/h10^4],[h4*h6/h10,h12*h4^2/h10^2,h4^5/h10^2]]);   \\invariants igusa, streng 
}


signes(i,j,k)=
{my(T);
T=[[0,0,0,0],[0,0,1,0],[0,0,0,1],[0,0,1,1],[1,0,0,0],[1,0,0,1],[0,1,0,0],[0,1,1,0],[1,1,0,0],[1,1,1,1]];

return((-1)^(T[i][1]+T[i][2]+T[j][1]+T[j][2]+T[k][1]+T[k][2]+T[i][1]*T[j][1]+T[i][2]*T[j][2]+T[i][4]*T[j][2]+T[i][1]*T[j][3]-T[i][2]*T[j][4]+T[i][1]*T[k][1]-T[i][3]*T[k][1]+T[j][1]*T[k][1]+T[i][2]*T[k][2]+T[j][2]*T[k][2]+T[j][4]*T[k][2]+T[j][1]*T[k][3]-T[i][2]*T[i][3]*T[j][1]-T[i][2]*T[i][4]*T[j][2]-T[i][1]*T[i][2]*T[j][3]-T[i][2]*T[i][3]*T[k][1]-T[i][3]*T[j][1]*T[k][1]-T[i][1]*T[j][3]*T[k][1]-T[i][2]*T[j][3]*T[k][1]-T[i][2]*T[i][4]*T[k][2]-T[i][4]*T[j][2]*T[k][2]-T[i][1]*T[i][2]*T[k][3]-T[i][1]*T[j][1]*T[k][3]-T[i][2]*T[j][1]*T[k][3]));
}



JInvStrengFromBj(Th)=   \\ calcul les invariants Streng et les Igusa-Clebsch à partir des bj=th_i^2/th_0^2   
{my(h4,h10,h12,h6,T,s,L);

h4=0;
for(i=1,10,h4+=Th[i]^4);
h10=prod(i=1,10,Th[i]);

L=[(Th[1]*Th[2]*Th[3]*Th[5]*Th[7]*Th[10])^2,(Th[1]*Th[2]*Th[3]*Th[6]*Th[8]*Th[9])^2,(Th[1]*Th[2]*Th[4]*Th[5]*Th[8]*Th[10])^2,(Th[1]*Th[2]*Th[4]*Th[6]*Th[7]*Th[9])^2,(Th[1]*Th[2]*Th[5]*Th[6]*Th[9]*Th[10])^2,(Th[1]*Th[3]*Th[4]*Th[5]*Th[8]*Th[9])^2,(Th[1]*Th[3]*Th[4]*Th[6]*Th[7]*Th[10])^2,(Th[1]*Th[3]*Th[7]*Th[8]*Th[9]*Th[10])^2,(Th[1]*Th[4]*Th[5]*Th[6]*Th[7]*Th[8])^2,(Th[2]*Th[3]*Th[4]*Th[5]*Th[7]*Th[9])^2,(Th[2]*Th[3]*Th[4]*Th[6]*Th[8]*Th[10])^2,(Th[2]*Th[3]*Th[5]*Th[6]*Th[7]*Th[8])^2,(Th[2]*Th[4]*Th[7]*Th[8]*Th[9]*Th[10])^2,(Th[3]*Th[4]*Th[5]*Th[6]*Th[9]*Th[10])^2,(Th[5]*Th[6]*Th[7]*Th[8]*Th[9]*Th[10])^2];

h12=sum(i=1,15,L[i]);

/****
M=[(Th[4]^4+Th[6]^4+Th[8]^4+Th[9]^4),(Th[4]^4+Th[5]^4+Th[7]^4+Th[10]^4),(Th[3]^4+Th[6]^4+Th[7]^4+Th[9]^4),(Th[3]^4+Th[5]^4+Th[8]^4+Th[10]^4),(Th[3]^4+Th[4]^4+Th[7]^4+Th[8]^4),(Th[2]^4+Th[6]^4+Th[7]^4+Th[10]^4),(Th[2]^4+Th[5]^4+Th[8]^4+Th[9]^4),(Th[2]^4+Th[4]^4+Th[5]^4+Th[6]^4),(Th[2]^4+Th[3]^4+Th[9]^4+Th[10]^4),(Th[1]^4+Th[6]^4+Th[8]^4+Th[10]^4),(Th[1]^4+Th[5]^4+Th[7]^4+Th[9]^4),(Th[1]^4+Th[4]^4+Th[9]^4+Th[10]^4),(Th[1]^4+Th[3]^4+Th[5]^4+Th[6]^4),(Th[1]^4+Th[2]^4+Th[7]^4+Th[8]^4),(Th[1]^4+Th[2]^4+Th[3]^4+Th[4]^4)];

h16=sum(i=1,15,L[i]*M[i]);
****/

T=[[0,0,0,0],[0,0,1,0],[0,0,0,1],[0,0,1,1],[1,0,0,0],[1,0,0,1],[0,1,0,0],[0,1,1,0],[1,1,0,0],[1,1,1,1]];

h6=0;
for(i=1,7,for(j=i+1,8,for(k=j+1,9,for(l=k+1,10,
   s=T[i]+T[j]+T[k]+T[l];
   if(s[1]%2==0&&s[2]%2==0&&s[3]%2==0&&s[4]%2==0,
      h6+=signes(i,j,k)*(Th[i]*Th[j]*Th[k])^2+
          signes(i,j,l)*(Th[i]*Th[j]*Th[l])^2+
          signes(i,k,l)*(Th[i]*Th[k]*Th[l])^2+
          signes(j,k,l)*(Th[j]*Th[k]*Th[l])^2)))));

return([[h4*h6/h10,h12*h4^2/h10^2,h4^5/h10^2],[h12/h10,h4,h12*h4/h10/3-2/3*h6,h10]]);

\\ return([[h12^5/h10^6,h4*h12^3/h10^4,h16*h12^2/h10^4],[h4*h6/h10,h12*h4^2/h10^2,h4^5/h10^2]);  \\invariants Igusa et Streng
}



InvIgusaPol(P)=  \\ calcule les invariants d'Igusa et de Streng à partir d'une courbe hyperelliptique 
{my(I2,I4,I6,I6p,I10,F,G,E,a);

E=polroots(P);
a=polcoeff(P,6);

I2=0;
for(i=2,6,F=diff([2,3,4,5,6],[i]);for(j=0,2,I2+=a^2*(E[1]-E[i])^2*(E[F[1]]-E[F[j+2]])^2*(E[F[(j+1)%3+2]]-E[F[(j-1)%3+2]])^2));
I4=0;
for(i=2,5,for(j=i+1,6,F=diff([2,3,4,5,6],[i,j]);
  I4+=a^4*(E[1]-E[i])^2*(E[1]-E[j])^2*(E[i]-E[j])^2*(E[F[1]]-E[F[2]])^2*(E[F[1]]-E[F[3]])^2*(E[F[2]]-E[F[3]])^2));
I6=0;
for(i=2,5,for(j=i+1,6,F=diff([2,3,4,5,6],[i,j]);
   for(k=1,3,G=diff(F,[F[k]]);for(l=1,2,I6+=a^6*(E[1]-E[i])^2*(E[1]-E[j])^2*(E[i]-E[j])^2*(E[F[1]]-E[F[2]])^2*(E[F[1]]-E[F[3]])^2*(E[F[2]]-E[F[3]])^2*(E[1]-E[F[k]])^2*(E[i]-E[G[l]])^2*(E[j]-E[G[(l)%2+1]])^2))));
I10=a^10;
for(i=1,5,for(j=i+1,6,I10*=(E[i]-E[j])^2));
I6p=(I2*I4-3*I6)/2;

return([[I2^5/I10,I4*I2^3/I10,I6*I2^2/I10], [I4*I6p/I10,I2*I4^2/I10,I4^5/I10^2]]); \\Igusa et Streng
}




                       /**** II) Evaluation des bj ****/


FormuleCosset(taup)=    \\renvoie (Th_i(taup)/Th_0(taup))^2, i=1,..,15, tau dans H2, en utilisant la formule de transformation   \\ compliqué pour rien (sic)
{my(gam,tau,Th,BB,Trans,Bj,A,B,C,D,nb,a,b,a2,b2,val,cd);

[gam,tau]=ReduceToF2(taup);
gam=gam^-1;	\\taup=gam.tau

\\Th=eval10theta2Newton(tau); 
Th=eval10theta2(tau);  

BB=[Th[2]/Th[1],Th[3]/Th[1],Th[4]/Th[1],Th[5]/Th[1],0,Th[6]/Th[1],0,Th[7]/Th[1],Th[8]/Th[1],0,0,Th[9]/Th[1],0,0,Th[10]/Th[1]];

Trans=FormTrans(gam)[1];
Bj=vector(15);
[A,B,C,D]=[gam[1..2,1..2],gam[1..2,3..4],gam[3..4,1..2],gam[3..4,3..4]];

if(Trans[1]==[0,0,0,0]~,
   for(i=1,15,
      nb=4*Trans[i+1][1]+8*Trans[i+1][2]+Trans[i+1][3]+2*Trans[i+1][4];
      [a,b]=[[(i>3&&i<8)||(i>11);i>7],[i%2==1;i%4==2||i%4==3]];

      Bj[i]=BB[nb]*exp(-I*Pi/2*(a~*A*B~*a+b~*C*D~*b+2*a~*B*C~*b+2*(a~*A+b~*C)*[(D~*B)[1,1];(D~*B)[2,2]])[1,1])),

   cd=1;while(Trans[cd+1]!=[0,0,0,0]~,cd++);
   nb=4*Trans[1][1]+8*Trans[1][2]+Trans[1][3]+2*Trans[1][4];
   [a,b]=[[(cd>3&&cd<8)||(cd>11);cd>7],[cd%2==1;cd%4==2||cd%4==3]];
   val=1/(BB[nb])*exp(-I*Pi/2*(a~*A*B~*a+b~*C*D~*b+2*a~*B*C~*b+2*(A~*a+C~*b)~*[(D~*B)[1,1];(D~*B)[2,2]])[1,1]);

   for(i=1,15,
      nb=4*Trans[i+1][1]+8*Trans[i+1][2]+Trans[i+1][3]+2*Trans[i+1][4];
      [a2,b2]=[[(i>3&&i<8)||(i>11);i>7],[i%2==1;i%4==2||i%4==3]];
      if(nb==0,Bj[i]=val,
         Bj[i]=val*BB[nb]*exp(-I*Pi/2*(a2~*A*B~*a2+b2~*C*D~*b2+2*a2~*B*C~*b2+2*(A~*a2+C~*b2)~*[(D~*B)[1,1];(D~*B)[2,2]])[1,1])/
	     exp(-I*Pi/2*(a~*A*B~*a+b~*C*D~*b+2*a~*B*C~*b+2*(A~*a+C~*b)~*[(D~*B)[1,1];(D~*B)[2,2]])[1,1])));
);

\\return([Bjp[1],Bjp[2],Bjp[3]]);
return(Bj);
}


EvalBj(tau)= \\calcule Theta_i^2/Theta_0^2, tau dans H2
{my(Th);
Th=Eval10Theta2(tau);
return([Th[2]/Th[1],Th[3]/Th[1],Th[4]/Th[1],Th[5]/Th[1],0,Th[6]/Th[1],0,Th[7]/Th[1],Th[8]/Th[1],0,0,Th[9]/Th[1],0,0,Th[10]/Th[1]]);
}


EvalBjp(tau)= \\ calcule bjp(tau), tau dans H2
{my(Bj,Bjp,cst);

Bj=FormuleCosset(tau);
\\Bj=EvalBj(tau);

cst=1/(1+Bj[4]+Bj[8]+Bj[12]);
Bjp=vector(3);
Bjp[1]=(Bj[1]+Bj[9])*cst;
Bjp[2]=(Bj[2]+Bj[6])*cst;
Bjp[3]=(Bj[3]+Bj[15])*cst;

return(Bjp);}



                               /**** III) Evaluation des theta ****/


Eval10Theta2(taup)= \\calcule th_i(taup)^2, i=0..15, tau dans H2 (renvoie les 10 pairs)   \\ il manque les facteurs Zeta(gam) et det(C.tau+D)
{my(gam,tau,trans,Trans,th,Th,Tab,Th2);

[gam,tau]=ReduceToF2(taup);
gam=gam^-1;  \\taup=gam.tau

trans=FormTrans(gam)[1];
Trans=[trans[1],trans[2],trans[3],trans[4],trans[5],trans[7],trans[9],trans[10],trans[13],trans[16]];

th=eval10theta2(tau);
Th=[th[1],th[2],th[3],th[4],th[5],0,th[6],0,th[7],th[8],0,0,th[9],0,0,th[10]];

Tab=[[[0;0],[0;0]],[[0;0],[1;0]],[[0;0],[0;1]],[[0;0],[1;1]],[[1;0],[0;0]],[[1;0],[0;1]],[[0;1],[0;0]],[[0;1],[1;0]],[[1;1],[0;0]],[[1;1],[1;1]]];

Th2=vector(10);
for(i=1,10,Th2[i]=expos(gam,Tab[i][1],Tab[i][2])^2*Th[4*Trans[i][1]+8*Trans[i][2]+Trans[i][3]+2*Trans[i][4]+1]);

\\Th2*matdet(gam[3..4,1..2]*tau+gam[3..4,3..4]);
return(Th2);
}

Rosenhain(tau)=
{my(T);
T=Eval10Theta2(tau);
return([T[1]*T[2]/T[4]/T[3],T[2]*T[9]/T[3]/T[10],T[1]*T[9]/T[4]/T[10]]);
}


EvalThetas(tau)= \\calcule (Theta_i)^2 par la formule de duplication
{my(T,V0,V1,V2,V3,V4,V6,V8,V9,V12,V15,R,Th);
T=vector(4);
R=vector(4);

Th=eval4theta(tau/2); \\ peut mal converger
for(i=1,4,T[i]=Th[i]^2);
for(j=1,4,R[j]=Th[j]);

V0=(T[1]+T[2]+T[3]+T[4])/4; 
V1=(R[1]*R[2]+R[3]*R[4])/2;
V2=(R[1]*R[3]+R[2]*R[4])/2;
V3=(R[1]*R[4]+R[2]*R[3])/2;
V4=(T[1]-T[2]+T[3]-T[4])/4;
V6=(R[1]*R[3]-R[2]*R[4])/2;
V8=(T[1]+T[2]-T[3]-T[4])/4;
V9=(R[1]*R[2]-R[3]*R[4])/2;
V12=(T[1]-T[2]-T[3]+T[4])/4;
V15=(R[1]*R[4]-R[2]*R[3])/2;

return([V0,V1,V2,V3,V4,V6,V8,V9,V12,V15]);
}




ThetasForF2(tau)= \\calcule Thetas0-15, tau dans F2
{my(Th,Th1,Th2,Th3,P1,P2,P3,x);
x='x;
\\Th1=Thetasg2(tau,N);  \\ thetas0-3
Th1=eval4theta(tau);  \\ thetas0-3
Th=vector(4,i,Th1[i]^2);
P1=x^2+(Th[2]^2+Th[4]^2-Th[1]^2-Th[3]^2)*x+(Th[1]*Th[3]-Th[2]*Th[4])^2;
P2=x^2+(Th[3]^2+Th[4]^2-Th[1]^2-Th[2]^2)*x+(Th[1]*Th[2]-Th[3]*Th[4])^2;
P3=x^2+(Th[2]^2+Th[3]^2-Th[1]^2-Th[4]^2)*x+(Th[1]*Th[4]-Th[2]*Th[3])^2;

Th2=concat(polroots(P1),concat(polroots(P2),polroots(P3))); \\Thetas4-15 puissance 4
Th2=vector(6,i,Th2[i]^(1/4));

Th3=ApproxThetas(tau,Th2);

return(concat(Th1,Th3));
}



ApproxThetas(tau,Th)= \\ calcule Thetas4-15 grâce à un calcul à faible précision
{my(q1,q2,q3,Tab,som,B,a0,a1,b0,b1,Theta,T,cst,cst2,som2,q11,q22,q31,q32);

q1=exp(Pi*I*tau[1,1]);
q2=exp(Pi*I*tau[2,2]);
q3=exp(2*I*Pi*tau[1,2]);

Tab=[[[1,0],[0,0]],[[1,0],[0,1]],[[0,1],[0,0]],[[0,1],[1,0]],[[1,1],[0,0]],[[1,1],[1,1]]];
Theta=vector(6);

for(i=1,6,
   B=2;
   T=[0,0];
   a0=Tab[i][1][1];
   a1=Tab[i][1][2];
   b0=Tab[i][2][1];
   b1=Tab[i][2][2];
   q11=q1^a0;
   q22=q2^a1;
   q31=q3^(a0/2);
   q32=q3^(a1/2);
   cst=(-1)^(a0/2*b0+a1/2*b1)*q1^((a0/2)^2)*q2^((a1/2)^2)*q3^((a0/2)*(a1/2));     
   while(T==[0,0],        
      som=0;
      for(n=-B,B, 
         if(n!=0,
	    som+=(-1)^(n*b0)*q1^(n^2)*(q11^n*q32^n);
	    cst2=(-1)^(n*b1)*q2^(n^2)*(q22^n*q31^n);
	    som2=0;
         for(m=1,B,
               som2+=(-1)^(m*b0)*q1^(m^2)*(q11^m*q3^(m*n)*q32^m+q11^(-m)*q3^(-m*n)*q32^(-m)));
	 som+=cst2*(1+som2)));     

      T=plusproche(cst*(1+som),[Th[2*truncate((i+1)/2)-1],Th[2*truncate((i+1)/2)]]);
      B=2*B;
    );

   Theta[i]=Th[2*truncate((i+1)/2)+T[1]]*T[2]);
   
return(Theta);
};

plusproche(x,L)=
{my(precs);
precs=3;while(round(x*10^precs)==0&&precs<100,precs++);while(precs<100&&round((L[1]-L[2])*10^(precs))==0,precs++);precs+=3;
\\precs=20;
for(i=1,4,if(proches(x,I^i*L[1],precs),return([-1,I^i]));if(proches(x,I^i*L[2],precs),return([0,I^i])));return([0,0])};
\\ il faut éviter le cas où x=0.00...004875 avec nb "0" >precs.

proches(x,y,precs)=
{return(truncate(real(x)*10^precs)-truncate(real(y)*10^precs)==0&&truncate(imag(x)*10^precs)-truncate(imag(y)*10^precs)==0)};




newlog2(x)={return(log(x)/log(2));}

Thetasg2(tau,N)=  \\ calcule theta0-3    converge bien si tau dans F2   même chose que  eval4theta(tau)
{my(B,q1,q2,q3,q4,a,b,Q,S,Q2,Q3,Q4,a3,a4,b2,c2,A0,A1,A2,A3,s);
B=floor(sqrt(4*(N-newlog2(40))/(Pi*newlog2(exp(1))*sqrt(3))));
q1=exp(Pi*I*tau[1,1]);
q2=exp(Pi*I*tau[2,2]);
q3=exp(2*I*Pi*tau[1,2]);
q4=q3^-1;
a=q1;
b=q1^2;
Q=vector(B);
Q[1]=q1;
for(m=2,B,a=a*b;Q[m]=a*Q[m-1]);
S=vector(4);
Q2=1;
a3=1;
a4=1;
b2=q2;
c2=q2^2;
for(n=1,B,
  a3*=q3;
  a4*=q4;
  Q2*=b2;
  b2*=c2;
  S[1]+=Q[n];
  S[2]+=(-1)^n*Q[n];
  S[3]+=Q[n];
  S[4]+=(-1)^n*Q[n];
  Q3=1;
  Q4=1;
  A0=1;
  A1=1;
  A2=(-1)^n;
  A3=(-1)^n;
  for(m=1,B,
    Q3*=a3;
    Q4*=a4;
    s=Q[m]*(Q3+Q4);
    A0+=s;
    A1+=(-1)^m*s;
    A2+=(-1)^n*s;
    A3+=(-1)^(m+n)*s);
  S[1]+=Q2*A0;
  S[2]+=Q2*A1;
  S[3]+=Q2*A2;
  S[4]+=Q2*A3);
return([1+2*S[1],1+2*S[2],1+2*S[3],1+2*S[4]]);
}



/********** FIN Evaluation des fct theta **********/
/**************************************************/

/********** DEBUT Formules de Thomae **************/
dansL(L,x)=
{for(i=1,length(L),if(L[i]==x,return(1)));
return(0);
}

inter(L,M)=
{my(N);
N=[];
for(i=1,length(L),if(dansL(M,L[i]),N=concat(N,[L[i]])));
return(N);
}

diffsym(L,M)=
{my(N1,N2);
N1=inter(L,M);
N2=[];
for(i=1,length(L),if(!dansL(N1,L[i]),N2=concat(N2,[L[i]])));
for(i=1,length(M),if(!dansL(N1,M[i]),N2=concat(N2,[M[i]])));
return(N2);
}

diff(L,M)=
{my(N);
N=[];
for(i=1,length(L),if(!dansL(M,L[i]),N=concat(N,[L[i]])));
return(N);
}

sousens(E,F)=
{if(length(E)==0,return([F]),
return(concat(sousens(diff(E,[E[1]]),F),sousens(diff(E,[E[1]]),concat(F,E[1])))));
}


etaS(S)=
{my(som,T);
som=[0,0,0,0];
T=[[1,0,0,0],[1,0,1,0],[0,1,1,0],[0,1,1,1],[0,0,1,1],[0,0,0,0]];
for(i=1,length(S),som=(som+T[S[i]])%2);
return((8*som[1]+4*som[2]+2*som[3]+1*som[4]));
}


Thomae(S2,U,E)=
{my(M,thet,S,F);
S=S2;
for(i=1,length(S),S[i]=E[S[i]]);
M=diffsym(S,U);
if(length(M)!=3,return(0),
	F=diff(E,M);
	thet=(-1)^(length(inter(S,U)))*
             prod(i=1,length(M),prod(j=1,length(F),1/(M[i]-F[j]))));
return(thet);
}

bjthomae(E)=
{my(U,S,L,F,Th,a);
F=[1,2,3,4,5,6];
U=[E[2],E[4],E[6]];
S=sousens(F,[]);
S=diff(S,[[]]);
L=[];

for(i=1,length(S),if(length(S[i])%2==0,
       L=concat(L,[[etaS(S[i]),S[i],Thomae(S[i],U,E)]])));

for(i=1,length(L),if(L[i][1]==0,a=i;break));
Th=vector(15);
for(j=1,15,for(i=1,length(L),if(L[i][1]==j,if(length(L[i][2])<4,
   Th[j]=(1/L[a][3]*L[i][3])))));

return(Th);
}




ThomaeRose(E)=
{my(U,S,SS,L,F,Th,a);
F=[1,2,3,4,5];
U=[1,3,5];
S=sousens(F,[]);
S=diff(S,[[]]);
L=[];

for(i=1,length(S),if(length(S[i])==2||length(S[i])==3,
       SS=diff(F,S[i]);
       L=concat(L,[[etaS(diffsym(S[i],U)),S[i], prod(j=1,length(S[i])-1,prod(k=j+1,length(S[i]),E[S[i][j]]-E[S[i][k]]))*prod(j=1,length(SS)-1,prod(k=j+1,length(SS),E[SS[j]]-E[SS[k]]))]])));


for(i=1,length(L),if(L[i][1]==0,a=i;break));
Th=vector(15);
for(j=1,15,for(i=1,length(L),if(L[i][1]==j,if(length(L[i][2])<4,
  Th[j]=(1/L[a][3]*L[i][3])))));

return(Th);
}


/********** FIN Formules de Thomae ***********/
/*********************************************/


/************** DEBUT: E to Bj ***************/

proche3(X,Y,precs)=
{return(abs(real(X)-real(Y))<precs&&abs(imag(X)-imag(Y))<precs)};

proche4(X,Y,precs)=
{return(abs(X-Y)<precs||abs(X+Y)<precs||abs(X+I*Y)<precs||abs(X-I*Y)<precs)};



dansLL(L,el)=
{for(i=1,length(L),
  for(j=1,length(L[i]),
   if(L[i][j]==el,return(1))));
return(0);
}

EvalBjFromCurveEq(E,realprec)=                         \\ à arranger
{my(tau,BjT,BB,Bj,Tab,cst,test,cd,precs,test2);

precs=10^-50;

default(realprecision,400);
tau=ReduceToF2(hcInit(E))[2];    \\precision ??
default(realprecision,realprec);

BjT=bjthomae(E);
BB=EvalBj(tau);

Tab=vector(15,i,[]);
Bj=vector(15);
cst=1;

test=0;
test2=0;
for(i=1,15,if(proche4(BB[1]^2,BjT[i],precs),
   test=1;
   test2=1;
   for(i=1,15,
      for(j=1,15,
         if(proche4(BB[i]^2,BjT[j]*cst,precs), 
            Tab[i]=concat(Tab[i],[j]))));
    for(i=1,15,if(Tab[i]==[],Tab[i]=[cd];BjT[cd]=1))));


if(test==0,
   for(i=1,15,
      for(j=1,15,
         if(test2==0&&abs(BjT[i])>precs&&proche4(1/BjT[i],BB[j]^2,precs),   \\cas foireux: plusieurs solutions mais une seule bonne
            test=1;cd=i;cst=1/BjT[i]; 
            for(ii=1,15,
   	       for(jj=1,15,
      	          if(proche4(BB[ii]^2,BjT[jj]*cst,precs),                    \\cas foireux: plusieurs valeurs identiques (mod +I,-I,-1): deux fois la même dans Tab et donc une absente
         	     Tab[ii]=concat(Tab[ii],[jj]))));
                                                                             \\ marche pas forcément:           for(kk=1,15,if(Tab[kk]==[],Tab[kk]=[cd];BjT[cd]=1;));
            Tab[j]=[cd];BjT[cd]=1;
            if(dansLL(Tab,1)&&dansLL(Tab,2)&&dansLL(Tab,3)&&dansLL(Tab,4)&&dansLL(Tab,6)&&dansLL(Tab,8)&&dansLL(Tab,9)&&dansLL(Tab,12)&&dansLL(Tab,15),test2=1)))));

if(test==0||test2==0,print("problème 4"));

for(i=1,15,
   test=0;
   for(j=1,length(Tab[i]),
      if(test==0&&proche3(BB[i],sqrt(cst*BjT[Tab[i][j]]),precs),test=1;Bj[i]=sqrt(cst*BjT[Tab[i][j]]),
      if(test==0&&proche3(BB[i],-sqrt(cst*BjT[Tab[i][j]]),precs),test=1;Bj[i]=-sqrt(cst*BjT[Tab[i][j]]),
      if(test==0&&proche3(BB[i],I*sqrt(cst*BjT[Tab[i][j]]),precs),test=1;Bj[i]=I*sqrt(cst*BjT[Tab[i][j]]),
      if(test==0&&proche3(BB[i],-I*sqrt(cst*BjT[Tab[i][j]]),precs),test=1;Bj[i]=-I*sqrt(cst*BjT[Tab[i][j]])
      ))))
   );
  if(test==0,print("problème 5"))
);

return(Bj);
}

/************** FIN E to Bj ***************/
/******************************************/


